unit Form_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ThemeMgr,

  U_SourceCodeFormatter_KRL, U_Config;

type
  TKRLSCF_MainForm = class(TForm)
    Btn_Start: TBitBtn;
    OpenDialog1: TOpenDialog;
    ThemeManager1: TThemeManager;
    Btn_Info: TBitBtn;
    GroupBox_Capitalization: TGroupBox;
    ComboBox_ProgramFlowStrings: TComboBox;
    Label3: TLabel;
    Label5: TLabel;
    ComboBox_SetupCommandStrings: TComboBox;
    Label4: TLabel;
    ComboBox_MathAndFunctionStrings: TComboBox;
    Label6: TLabel;
    ComboBox_IOCommandStrings: TComboBox;
    Label7: TLabel;
    ComboBox_TypeDefinitionStrings: TComboBox;
    Label8: TLabel;
    ComboBox_SystemVariableStrings: TComboBox;
    Label9: TLabel;
    ComboBox_OpusTechFunctionStrings: TComboBox;
    Label10: TLabel;
    ComboBox_MotionCommandStrings: TComboBox;
    GroupBox_Spacing: TGroupBox;
    CheckBox_SpacingOperators: TCheckBox;
    GroupBox_Indent: TGroupBox;
    Label1: TLabel;
    Spin_IdentWidth: TSpinEdit;
    procedure Btn_StartClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Btn_InfoClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    FBusy: Boolean;
    procedure SetBusy(Value: Boolean);
  public
    { Public-Deklarationen }
    property Busy: Boolean read FBusy write SetBusy;
  end;

var
  KRLSCF_MainForm: TKRLSCF_MainForm;

implementation

uses Form_Info;

{$R *.DFM}
{==============================================================================}

procedure TKRLSCF_MainForm.SetBusy(Value: Boolean);
begin
  FBusy := Value;
  Btn_Start.Enabled := not FBusy;
  Btn_Info.Enabled := not FBusy;
  GroupBox_Capitalization.Enabled := not FBusy;
  ComboBox_ProgramFlowStrings.Enabled := not FBusy;
  Label3.Enabled := not FBusy;
  Label5.Enabled := not FBusy;
  ComboBox_SetupCommandStrings.Enabled := not FBusy;
  Label4.Enabled := not FBusy;
  ComboBox_MathAndFunctionStrings.Enabled := not FBusy;
  Label6.Enabled := not FBusy;
  ComboBox_IOCommandStrings.Enabled := not FBusy;
  Label7.Enabled := not FBusy;
  ComboBox_TypeDefinitionStrings.Enabled := not FBusy;
  Label8.Enabled := not FBusy;
  ComboBox_SystemVariableStrings.Enabled := not FBusy;
  Label9.Enabled := not FBusy;
  ComboBox_OpusTechFunctionStrings.Enabled := not FBusy;
  Label10.Enabled := not FBusy;
  ComboBox_MotionCommandStrings.Enabled := not FBusy;
  GroupBox_Spacing.Enabled := not FBusy;
  CheckBox_SpacingOperators.Enabled := not FBusy;
  GroupBox_Indent.Enabled := not FBusy;
  Label1.Enabled := not FBusy;
  Spin_IdentWidth.Enabled := not FBusy;
  Application.ProcessMessages;
end;
{==============================================================================}

procedure TKRLSCF_MainForm.Btn_StartClick(Sender: TObject);
var i: Integer;
begin
  Busy := True;
  try

    SaveConfig_GUI;

    if OpenDialog1.Execute then
    begin
      for i := 0 to OpenDialog1.Files.Count - 1 do
      begin
        FormatSource(OpenDialog1.Files[i]);
      end;
      ShowMessage('Formating done...');
    end;
  finally
    Busy := False;
  end;

end;
{==============================================================================}

procedure TKRLSCF_MainForm.FormShow(Sender: TObject);
begin
  Busy := False;
  LoadConfig_GUI;
end;
{==============================================================================}

procedure TKRLSCF_MainForm.Btn_InfoClick(Sender: TObject);
begin
  KRLSCF_InfoDialog.ShowModal;
end;
{==============================================================================}

procedure TKRLSCF_MainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SaveConfig_GUI;
end;

end.

